--
-- TR_INFO.lua
-- Resource file for Mobj objects, states and sounds
-- 
-- By Flame
-- 3/24/20
--

-- Objects
freeslot("MT_TRONTRAIL")
freeslot("MT_PHANTOMTRAIL")
freeslot("MT_KAMIKAZESHIELD")
freeslot("MT_KAMIKAZEGATHER")
freeslot("MT_KAMIKAZEALERT")
freeslot("MT_FASTTRAIL")
freeslot("MT_RESPAWNFX")
-- States
freeslot("S_TRONTRAIL")
freeslot("S_PHANTOMTRAIL")
freeslot("S_FASTTRAIL")
freeslot("S_RESPAWN1")
freeslot("S_KALERT")
-- Sprites
freeslot("SPR_NTHK")
freeslot("SPR_FAST")
freeslot("SPR_DEZL")
freeslot("SPR_KWAR")
-- Gametype?
freeslot("TOL_TRON")

--Let's get started!
local thing

-- Objects --
thing = MT_TRONTRAIL
mobjinfo[thing].spawnstate = S_TRONTRAIL
mobjinfo[thing].radius = 48*FRACUNIT
mobjinfo[thing].height = 48*FRACUNIT
mobjinfo[thing].flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SCENERY

thing = MT_PHANTOMTRAIL
mobjinfo[thing].spawnstate = S_PHANTOMTRAIL
mobjinfo[thing].radius = 16*FRACUNIT
mobjinfo[thing].height = 48*FRACUNIT
mobjinfo[thing].flags = MF_NOBLOCKMAP|MF_NOGRAVITY

thing = MT_KAMIKAZESHIELD
mobjinfo[thing].spawnstate = S_MSSHIELD_F1
mobjinfo[thing].radius = 32*FRACUNIT
mobjinfo[thing].height = 64*FRACUNIT
mobjinfo[thing].flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY

thing = MT_KAMIKAZEGATHER
mobjinfo[thing].spawnstate = S_JETFUME1
mobjinfo[thing].radius = 6*FRACUNIT
mobjinfo[thing].height = 12*FRACUNIT
mobjinfo[thing].flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY

thing = MT_FASTTRAIL
mobjinfo[thing].spawnstate = S_FASTTRAIL
mobjinfo[thing].radius = 5*FRACUNIT
mobjinfo[thing].height = 5*FRACUNIT
mobjinfo[thing].flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SCENERY

thing = MT_RESPAWNFX
mobjinfo[thing].spawnstate = S_RESPAWN1
mobjinfo[thing].radius = 28*FRACUNIT
mobjinfo[thing].height = 16*FRACUNIT
mobjinfo[thing].flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_SCENERY

thing = MT_KAMIKAZEALERT
mobjinfo[thing].spawnstate = S_KALERT
mobjinfo[thing].radius = 16*FRACUNIT
mobjinfo[thing].height = 16*FRACUNIT
mobjinfo[thing].flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY

-- States --
thing = S_TRONTRAIL
--states[thing].sprite = SPR_PLAY
states[thing].sprite = SPR_NTHK
states[thing].frame = 0|FF_TRANS50
states[thing].tics = -1
states[thing].nextstate = S_NULL

thing = S_PHANTOMTRAIL
states[thing].sprite = SPR_PLAY
states[thing].frame = 0|FF_TRANS50
states[thing].tics = -1
states[thing].nextstate = S_NULL

thing = S_FASTTRAIL
states[thing].sprite = SPR_FAST
states[thing].frame = 0|FF_ANIMATE|FF_PAPERSPRITE
states[thing].tics = 10
states[thing].var1 = 5
states[thing].var2 = 2
states[thing].nextstate = S_NULL

thing = S_RESPAWN1
--states[thing].sprite = SPR_PLAY
states[thing].sprite = SPR_DEZL
states[thing].frame = 0|FF_PAPERSPRITE
states[thing].tics = -1
states[thing].nextstate = S_NULL

thing = S_KALERT
states[thing].sprite = SPR_KWAR
states[thing].frame = 0
states[thing].tics = -1
states[thing].nextstate = S_NULL

thing = MT_SPINFIRE
mobjinfo[thing].flags = MF_NOBLOCKMAP

rawset(_G, "vanillacollectables", {
	MT_BOUNCERING,
	MT_RAILRING,
	MT_INFINITYRING,
	MT_AUTOMATICRING,
	MT_EXPLOSIONRING,
	MT_SCATTERRING,
	MT_GRENADERING,
	MT_BOUNCEPICKUP,
	MT_RAILPICKUP,
	MT_AUTOPICKUP,
	MT_EXPLODEPICKUP,
	MT_SCATTERPICKUP,
	MT_GRENADEPICKUP
})

G_AddGametype({
    name = "Tron",
    identifier = "Tron", --GT_TRON
    typeoflevel = TOL_MATCH|TOL_TRON,
    rules = GTR_RINGSLINGER|GTR_SPECTATORS|GTR_TIMELIMIT|GTR_POINTLIMIT|GTR_OVERTIME|GTR_RESPAWNDELAY|GTR_HURTMESSAGES|GTR_DEATHMATCHSTARTS|GTR_DEATHPENALTY,
    intermissiontype = int_match,
	rankingtype = GT_MATCH,
	defaulttimelimit = 5,
    headercolor = 155,
    description = "Outmaneuver your opponents as you move in a maze like pattern! Force the enemy into walls and even your own jet trail, while simultaneously avoiding their own trails!"
})