--
-- TRON-Player.lua
-- Execute player related functions from TR_Gameplay.Lua
-- 
-- By Flame
-- 3/30/20
--

addHook("PlayerSpawn", function(p)
	if (gametype == GT_TRON)
		if p and p.valid and not p.spectator
		and p.mo and p.mo.valid
			TR.Game.tronRespawn(p)
		end
	end
end)

-- Pre-game thinker. Force controls.
addHook("PreThinkFrame", do
	if (gametype == GT_TRON)
		for p in players.iterate
			if not p.spectator
			and (p.playerstate != PST_DEAD)
			and (p.mo.state != S_PLAY_DEAD)
				TR.Game.tronPreThink(p)
			end
		end
	end
end)

-- Player thinker
addHook("PlayerThink", function(p)
	if (gametype == GT_TRON)
		if p and p.valid and not p.spectator
		and p.mo and p.mo.valid
		and (p.playerstate != PST_DEAD)
		and (p.mo.state != S_PLAY_DEAD)
			TR.Game.tronThink(p)
			TR.Game.dotronTrail(p)
		end
	end
end)

-- Disallow certain functions in the TRON gametype
addHook("AbilitySpecial", do return (gametype == GT_TRON) end)
addHook("JumpSpinSpecial", do return (gametype == GT_TRON) end)
addHook("SpinSpecial", do return (gametype == GT_TRON) end)

